function [X_norm, mu, sigma] = featureNormalize(X)

%   FEATURENORMALIZE Normalizes the features in X 
%   FEATURENORMALIZE(X) returns a normalized version of X where
%   the mean value of each feature is 0
%   the standard deviation is 1.

% ====================== YOUR CODE HERE ======================
% Instructions: First, for each feature dimension, compute the mean
%               of the feature and subtract it from the dataset,
%               storing the mean value in mu. Next, compute the 
%               standard deviation of each feature and divide
%               each feature by it's standard deviation, storing
%               the standard deviation in sigma. 
%
%	Note that X is a matrix where 
%           each column is a feature and each row is an example. 
%           You need to perform the normalization separately
%           for each feature. 
% =============================================================     

mu = mean(X);
X_mu = X - repmat(mu,size(X,1),1);
sigma = std(X_mu);
X_norm = X_mu./repmat(sigma,size(X,1),1);

end
