function [theta, J_history] = gradientDescent(X, y, theta, alpha, num_iters)

%   GRADIENTDESCENT Performs gradient descent to learn theta
%   theta = GRADIENTDESENT(X, y, theta, alpha, num_iters) updates theta by 
%   taking num_iters gradient steps with learning rate alpha

m = length(y); % number of training examples
J_history = zeros(num_iters, 1);

for iter = 1:num_iters
    Xt_y = X*theta - y; % (m , 1)
    theta = theta - alpha/m*[sum(Xt_y.*X(:,1)) ; sum(Xt_y.*X(:,2))]; % (2 , 1)
    J_history(iter) = computeCost(X, y, theta);
end

end
