function [theta, J_history] = gradientDescentMulti(X, y, theta, alpha, num_iters)

%   GRADIENTDESCENTMULTI Performs gradient descent to learn theta
%   theta = GRADIENTDESCENTMULTI(x, y, theta, alpha, num_iters)
%   updates theta by taking num_iters gradient steps with learning rate alpha

m = length(y); % number of training examples
np1 = size(X,2); % number of features
J_history = zeros(num_iters, 1);

for iter = 1:num_iters
    Xt_y = X*theta - y; % (m , 1)
    theta = theta - (alpha/m*sum(repmat(Xt_y,1,np1).*X))';% (n+1 , 1)
    J_history(iter) = computeCostMulti(X, y, theta);
end

end
